Bug 875213 - Review Request: python-cssselect - Parses CSS3 Selectors and translates them to XPath 1.0
Summary: Review Request: python-cssselect - Parses CSS3 Selectors and translates them ...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Ralph Bean
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 873256 (view as bug list)
Depends On:
Blocks: 993406
TreeView+ depends on / blocked
 
Reported: 2012-11-09 20:13 UTC by Kevin Fenzi
Modified: 2014-08-14 11:48 UTC (History)
6 users (show)

Fixed In Version: python-cssselect-0.8-1.el6
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-12-13 15:34:55 UTC
rbean: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Kevin Fenzi 2012-11-09 20:13:38 UTC
Spec URL: http://www.scrye.com/~kevin/fedora/python-cssselect/python-cssselect.spec
SRPM URL: http://www.scrye.com/~kevin/fedora/python-cssselect/python-cssselect-0.7.1-1.fc18.src.rpm
Description: 

Cssselect parses CSS3 Selectors and translates them to XPath 1.0 expressions.
Such expressions can be used in lxml or another XPath engine to find the
matching elements in an XML or HTML document.

Fedora Account System Username: kevin

This package is needed for newer calibre versions.

Comment 1 Ralph Bean 2012-11-09 20:16:44 UTC
I'll take this one.

Comment 2 leigh scott 2012-11-09 20:21:19 UTC
I note a couple of things

is this needed

%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}


https://fedoraproject.org/wiki/Packaging:Python?rd=Packaging/Python#Macros



and for the %files section

change

%{python_sitelib}/*


to

%{python_sitelib}/cssselect/

Comment 3 Ralph Bean 2012-11-09 20:32:22 UTC
Leigh's comment about the files section is appropriate, but it should likely be broken into two lines to include egg-info as well.:

%{python_sitelib}/cssselect/
%{python_sitelib}/cssselect-%{version}-*

Issues:
=======

[!]: Package contains BR: python2-devel or python3-devel
See: http://fedoraproject.org/wiki/Packaging:Python#BuildRequires

[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required

     Are you planning on building this for el5?  If not, then this can be
     removed.


*SHOULD* items.. not blockers:

[!]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.

[!]: %check is present and all tests pass.
    This is only a SHOULD, but it should be pretty easy.  The tests exist
    and pass when I try to run them.  %check should just include
    "python cssselect/tests.py"::

        (scratch-sys)--- Source0/cssselect-0.7.1 ยป python cssselect/tests.py
        ............
        -------------------------------------------------------------------
        Ran 12 tests in 0.074s

        OK


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[-]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 1 files have unknown license. Detailed output of
     licensecheck in /home/threebean/875213-python-cssselect/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 30720 bytes in 7 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[!]: Package contains BR: python2-devel or python3-devel
[-]: Binary eggs must be removed in %prep
     Note: Cannot find sources under BUILD (using prebuilt sources?)
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[!]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[!]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (cssselect-0.7.1.tar.gz)
[x]: SourceX is a working URL.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: python-cssselect-0.7.1-1.fc18.src.rpm
          python-cssselect-0.7.1-1.fc18.noarch.rpm
python-cssselect.src: W: spelling-error %description -l en_US lxml -> XML
python-cssselect.noarch: W: spelling-error %description -l en_US lxml -> XML
2 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint python-cssselect
python-cssselect.noarch: W: spelling-error %description -l en_US lxml -> XML
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'



Requires
--------
python-cssselect-0.7.1-1.fc18.noarch.rpm (rpmlib, GLIBC filtered):
    
    /usr/bin/env
    python(abi) = 2.7



Provides
--------
python-cssselect-0.7.1-1.fc18.noarch.rpm:
    
    python-cssselect = 0.7.1-1.fc18



MD5-sum check
-------------
http://pypi.python.org/packages/source/c/cssselect/cssselect-0.7.1.tar.gz :
  CHECKSUM(SHA256) this package     : 74f411a349fcfb676b68336fcae8799ba9fbb0a0446562f544dee019fb0e2ae7
  CHECKSUM(SHA256) upstream package : 74f411a349fcfb676b68336fcae8799ba9fbb0a0446562f544dee019fb0e2ae7


Generated by fedora-review 0.3.1 (b71abc1) last change: 2012-10-16
Buildroot used: fedora-18-x86_64
Command line :/usr/bin/fedora-review -b 875213

Comment 4 Kevin Fenzi 2012-11-09 20:47:02 UTC
>Leigh's comment about the files section is appropriate, but it should likely be
>broken into two lines to include egg-info as well.:
>
>%{python_sitelib}/cssselect/
>%{python_sitelib}/cssselect-%{version}-*

Fixed. 

>[!]: Package contains BR: python2-devel or python3-devel
>See: http://fedoraproject.org/wiki/Packaging:Python#BuildRequires

Fixed. 

>[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
>     beginning of %install.
>    Note: rm -rf %{buildroot} present but not required
>
>     Are you planning on building this for el5?  If not, then this can be
>  removed.

Nope. Removed. 

> [!]: If the source package does not include license text(s) as a separate file
>     from upstream, the packager SHOULD query upstream to include it.

LICENSE is included as a %doc... is it not showing up right somehow?

>[!]: %check is present and all tests pass.
>    This is only a SHOULD, but it should be pretty easy.  The tests exist
>    and pass when I try to run them.  %check should just include
>    "python cssselect/tests.py"::

I actually looked at adding this before I submitted the package review, but the problem is that 
%check is done right after build, and the package isn't installed anywhere that check can read it. 
So, I would need to adjust the tests.py to look in the buildroot for things in order for it to work?

I'll note for amusement that all the above things I had to fix were set that way by rpmdev-newspec. Perhaps we could fix it's default python template up? 

Spec URL: http://www.scrye.com/~kevin/fedora/python-cssselect/python-cssselect.spec
SRPM URL: http://www.scrye.com/~kevin/fedora/python-cssselect/python-cssselect-0.7.1-2.fc18.src.rpm

Comment 5 leigh scott 2012-11-09 20:56:27 UTC
(In reply to comment #4)

> >     Are you planning on building this for el5?  If not, then this can be
> >  removed.
> 
> Nope. Removed. 

If that's the case the python macro is also surplus and can be removed

> Spec URL:
> http://www.scrye.com/~kevin/fedora/python-cssselect/python-cssselect.spec
> SRPM URL:
> http://www.scrye.com/~kevin/fedora/python-cssselect/python-cssselect-0.7.1-2.
> fc18.src.rpm

Comment 6 Ralph Bean 2012-11-09 21:20:01 UTC
Package is APPROVED!

(In reply to comment #4)
> > [!]: If the source package does not include license text(s) as a separate file
> >     from upstream, the packager SHOULD query upstream to include it.
> 
> LICENSE is included as a %doc... is it not showing up right somehow?

Wow.  You're right.  I don't know how I missed that.

> >[!]: %check is present and all tests pass.
> >    This is only a SHOULD, but it should be pretty easy.  The tests exist
> >    and pass when I try to run them.  %check should just include
> >    "python cssselect/tests.py"::
> 
> I actually looked at adding this before I submitted the package review, but
> the problem is that 
> %check is done right after build, and the package isn't installed anywhere
> that check can read it. 
> So, I would need to adjust the tests.py to look in the buildroot for things
> in order for it to work?

You might try "PYTHONPATH=$(pwd) python cssselect/tests.py"
You can add it after importing the srpm since this isn't a blocker.

> I'll note for amusement that all the above things I had to fix were set that
> way by rpmdev-newspec. Perhaps we could fix it's default python template up? 

Ah, I've not noticed it since I've been using pingou's pypi2spec for new packages.  I'll make a note to track that down.

Comment 7 Kevin Fenzi 2012-11-09 21:49:10 UTC
Thanks!

I'll play with the tests and see if I can get it working before import. I'll also nuke the python macro. 

New Package SCM Request
=======================
Package Name: python-cssselect
Short Description: Parses CSS3 Selectors and translates them to XPath 1.0
Owners: kevin
Branches: f17 f18
InitialCC:

Comment 8 Gwyn Ciesla 2012-11-09 22:24:37 UTC
Git done (by process-git-requests).

Comment 9 Bohuslav "Slavek" Kabrda 2012-12-07 14:08:19 UTC
Hi Kevin, I'd like to ask you to first search for already existing reviews on a package. 4 days before you, I submitted my review request for python-cssselect: https://bugzilla.redhat.com/show_bug.cgi?id=873256

This is not a rant, but some people might actually consider this rude :)

Thanks.

Comment 10 Bohuslav "Slavek" Kabrda 2012-12-07 14:08:34 UTC
*** Bug 873256 has been marked as a duplicate of this bug. ***

Comment 11 Kevin Fenzi 2012-12-07 14:18:54 UTC
Sorry. I thought I did check, I'm not sure why I didn't see the existing review. ;( 

You're quite welcome to co-maintain or make any improvements you like to the package. 

Feel free to apply in pkgdb.

Comment 12 Ralph Bean 2012-12-13 15:34:55 UTC
This package appears to have made it in as a part of the following update:

https://admin.fedoraproject.org/updates/FEDORA-2012-17938/python-cssselect-0.7.1-3.fc18,calibre-0.9.5-2.fc18

I'm closing the ticket as ERRATA.

Comment 13 Eric Smith 2013-07-25 21:04:28 UTC
Package Change Request
======================
Package Name: python-cssselect
New Branches: el6
Owners: kevin brouhaha

Comment 14 Gwyn Ciesla 2013-07-26 11:53:19 UTC
Git done (by process-git-requests).

Comment 15 Fedora Update System 2013-07-26 18:00:49 UTC
python-cssselect-0.8-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/python-cssselect-0.8-1.el6

Comment 16 Fedora Update System 2013-08-16 17:06:45 UTC
python-cssselect-0.8-1.el6 has been pushed to the Fedora EPEL 6 stable repository.

Comment 17 Eric Smith 2014-08-13 19:42:22 UTC
Package Change Request
======================
Package Name: python-cssselect
New Branches: epel7
Owners: kevin brouhaha

Comment 18 Gwyn Ciesla 2014-08-14 11:48:40 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.